Index: squid/src/HintCacheNet.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/HintCacheNet.c,v
retrieving revision 1.1.2.2
retrieving revision 1.1.2.3
diff -u -r1.1.2.2 -r1.1.2.3
--- squid/src/HintCacheNet.c	7 Dec 2001 23:25:31 -0000	1.1.2.2
+++ squid/src/HintCacheNet.c	21 May 2002 02:46:41 -0000	1.1.2.3
@@ -1,7 +1,7 @@
 /*
- * $Date: 2001/12/07 23:25:31 $ $Id: HintCacheNet.c,v 1.1.2.2 2001/12/07 23:25:31 jkay Exp $
+ * $Date: 2002/05/21 02:46:41 $ $Id: HintCacheNet.c,v 1.1.2.3 2002/05/21 02:46:41 jkay Exp $
  *
- * DEBUG: section 55    Hint cache networking.
+ * DEBUG: section 87    Hint cache networking.
  * AUTHOR: Mike Dahlin, UT Austin, 1998
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -33,173 +33,178 @@
  * Computer Sciences Department 
  * University of Texas at Austin
  *
- * HCNet --- Simple send interface built on squid async send stuff.
+ * hintCacheNet --- Simple send interface built on squid async send stuff.
  *------------------------------------------------------------------
  */
 
 #include "squid.h"
 #include <assert.h>
 
-#define HCNET_DEBUG 55
+#define HCNET_DEBUG 87
 
 #define RECV_DEBUG(type, u, hdr, src) \
-    debug(HCNET_DEBUG, 2, "Got %s: 0x%x at <%s,%d> from <%s,%d>\n", \
+    debug (HCNET_DEBUG, 2) ("Got %s: 0x%x at <%s,%d> from <%s,%d>\n", \
 	  (type), *(int *) &(u)->entry.key.key, \
 	  inet_ntoa((u)->entry.ipaddr), (u)->entry.port, \
 	  inet_ntoa((src)->sin_addr), (hdr)->httpport)
 
-static void enqueueBytes(HCNet *n, char *data, int nbytes);
-static int copyToLocal(HCUpdate *updatesA, char *data, int len, 
-		       int oneUpdateSize);
-static void clear(HCNet *n);
-static void updateHierarchy(HCUpdate *updatesA, int nupdates, 
-			    struct sockaddr_in *source);
-static void suppress(HCUpdate *updateA, int nupdates);
+static void enqueueBytes(HintCacheNet * n, char *data, int nbytes);
+static int copyToLocal(HintCacheUpdate * updatesA, char *data, int len,
+    int oneUpdateSize);
+static void clear(HintCacheNet * n);
+static void updateHierarchy(HintCacheUpdate * updatesA, int nupdates,
+    struct sockaddr_in *source);
+static void suppress(HintCacheUpdate * updateA, int nupdates);
 static void scoldParent(struct sockaddr_in *parent);
 
 void
-HCNet_Init(HCNet *n)
+hintCacheNetInit(HintCacheNet * n)
 {
 #ifdef DOTEST
-  n->testMode = 0;
-  n->testCount = 0;
+    n->testMode = 0;
+    n->testCount = 0;
 #endif
-  clear(n);
+    clear(n);
 }
 
 static void
-clear(HCNet *n)
+clear(HintCacheNet * n)
 {
-  HCNetHeader hdr;
-  const char *url = "route://updates";
-  int flags = 0;
-
-  assert(n);
-
-  /* Set up entry with request */
-  EBIT_SET(flags, REQ_CACHABLE);
-  EBIT_SET(flags, ENTRY_SPECIAL);  /* formerly set KEEP_INMEM */
-/*   EBIT_SET(flags, DONT_FREE_FOR); */
-  n->sendBuffer = storeCreateEntry(url, url, NULL, 0, flags, METHOD_GET);
-  n->sendBuffer->mem_obj->request = 
-    requestLink(urlParse(METHOD_GET, (char *) url));
-  
-  n->sendLength = 0;
-
-  n->state = HC_filling;
-
-  /* Prepare header for next transmission */
-  hdr.httpport = htons(Config.Port.http);
-  hdr.updlen = htons(sizeof(Net_HCUpdate));
-  enqueueBytes(n, (char *) &hdr, sizeof(hdr));
+    HintCacheNetHeader hdr;
+    const char *url = "route://updates";
+    request_flags rflags;
+    StoreEntry *entry;
+
+    assert(n);
+
+    /* Set up entry with request */
+    *(unsigned int *) &rflags = 0;
+    rflags.cachable = 1;
+    entry = storeCreateEntry(url, url, rflags, METHOD_GET);
+    n->sendBuffer = entry;
+    EBIT_SET(entry->flags, ENTRY_SPECIAL);	/* formerly set KEEP_INMEM */
+/*   EBIT_SET(entry->flags, DONT_FREE_FOR); */
+    n->sendBuffer->mem_obj->request =
+	requestLink(urlParse(METHOD_GET, (char *) url));
+
+    n->sendLength = 0;
+
+    n->state = HC_filling;
+
+    /* Prepare header for next transmission */
+    hdr.httpport = htons(Config.Sockaddr.http->s.sin_port);
+    hdr.updlen = htons(sizeof(HintCacheUpdateNet));
+    enqueueBytes(n, (char *) &hdr, sizeof(hdr));
 }
 
-void HCNet_Destroy(HCNet *n)
+void
+hintCacheNetDestroy(HintCacheNet * n)
 {
-  storeRelease(n->sendBuffer);
-  n->state = HC_destroyed;
+    storeRelease(n->sendBuffer);
+    n->state = HC_destroyed;
 }
 
-void 
-HCNet_Enqueue(HCNet *n, int action, HCEntry *entry, int hopcount)
+void
+hintCacheNetEnqueue(HintCacheNet * n, int action, HintCacheEntry * entry, int hopcount)
 {
-  HCUpdate update;
-  Net_HCUpdate netUpdate;
+    HintCacheUpdate update;
+    HintCacheUpdateNet netUpdate;
 
 #ifdef DOTEST
-  if(n->testMode){
-    n->testCount++;
-    return;
-  }
+    if (n->testMode) {
+	n->testCount++;
+	return;
+    }
 #endif
-  debug(HCNET_DEBUG, 4,
-	"HCNet_Enqueue onto 0x%x (action %d) (entry.key %llx entry.ipaddr %s port %d)\n", 
+    debug(HCNET_DEBUG, 4)
+	("HCNet_Enqueue onto 0x%x (action %d) (entry.key %llx entry.ipaddr %s port %d)\n",
 	n, action, entry->key.key, inet_ntoa(entry->ipaddr), entry->port);
 
-  HCUpdate_Init(&update, action, entry, hopcount);
-  Net_HCUpdate_Init(&netUpdate, &update);
-  enqueueBytes(n, (char *)&netUpdate, sizeof(Net_HCUpdate));
+    hintCacheUpdateInit(&update, action, entry, hopcount);
+    hintCacheUpdateNetInit(&netUpdate, &update);
+    enqueueBytes(n, (char *) &netUpdate, sizeof(HintCacheUpdateNet));
 }
 
 static void
-enqueueBytes(HCNet *n, char *data, int nbytes)
+enqueueBytes(HintCacheNet * n, char *data, int nbytes)
 {
-  static enqreentrancy = 0;
+    static enqreentrancy = 0;
 
-  assert(n->state == HC_filling);
-  assert(!enqreentrancy);
-  ++enqreentrancy;
-  n->sendLength += nbytes;
-  storeAppend(n->sendBuffer, data, nbytes);
-  --enqreentrancy;
+    assert(n->state == HC_filling);
+    assert(!enqreentrancy);
+    ++enqreentrancy;
+    n->sendLength += nbytes;
+    storeAppend(n->sendBuffer, data, nbytes);
+    --enqreentrancy;
 }
 
 int
-HCNet_bytesReady(HCNet *n)
+hintCacheNetBytesReady(HintCacheNet * n)
 {
-  return n->sendLength;
+    return n->sendLength;
 }
 
 void
-HCNet_Complete(HCNet *n)
+hintCacheNetComplete(HintCacheNet * n)
 {
 
-  assert(n);
-  assert(n->state == HC_filling);
-  n->state = HC_full;
-  HCFinishHeader(n->sendBuffer);
-  storeComplete(n->sendBuffer);
+    assert(n);
+    assert(n->state == HC_filling);
+    n->state = HC_full;
+    hintCacheFinishHeader(n->sendBuffer);
+    storeComplete(n->sendBuffer);
 }
 
 void
-HCNet_SendTo(HCNet *n, struct sockaddr_in *dest)
+hintCacheNetSendTo(HintCacheNet * n, struct sockaddr_in *dest)
 {
-  assert(n->state == HC_full);
-  assert(n->sendLength > sizeof(HCNetHeader));
-  debug(HCNET_DEBUG, 2, "HCNet_SendTo: sending routes on 0x%x to <%s,%d>\n",
+    assert(n->state == HC_full);
+    assert(n->sendLength > sizeof(HintCacheNetHeader));
+    debug(HCNET_DEBUG, 2) ("HCNet_SendTo: sending routes on 0x%x to <%s,%d>\n",
 	n, inet_ntoa(dest->sin_addr), dest->sin_port);
-  putSend(n->sendBuffer, dest, NULL, NULL, 0, 0);
+    putSend(n->sendBuffer, dest, NULL, NULL, 0);
 }
 
 void
-HCNet_Done(HCNet *n)
+hintCacheNetDone(HintCacheNet * n)
 {
-  StoreEntry *entry = n->sendBuffer;
-  
-  assert(n->state == HC_full);
-
-  EBIT_CLR(entry->flag, KEEP_INMEM);
-  EBIT_SET(entry->flag, RELEASE_REQUEST);
-  storeUnlockObject(entry);
-  
-  clear(n);
+    StoreEntry *entry = n->sendBuffer;
+
+    assert(n->state == HC_full);
+
+    EBIT_CLR(entry->flags, ENTRY_SPECIAL);     /* formerly KEEP_INMEM flag */
+
+    EBIT_SET(entry->flags, RELEASE_REQUEST);
+    storeUnlockObject(entry);
+
+    clear(n);
 }
 
 
 #ifdef DOTEST
 void
-HCNet_SetTestMode(HCNet *n)
+hintCacheNetSetTestMode(HintCacheNet * n)
 {
-  n->testMode = 1;
-  n->testCount = 0;
+    n->testMode = 1;
+    n->testCount = 0;
 }
 
 int
-HCNet_GetTestCount(HCNet *n)
+hintCacheNetGetTestCount(HintCacheNet * n)
 {
-  return n->testCount;
+    return n->testCount;
 }
 #endif /* DOTEST */
 
 /*
  *------------------------------------------------------------------
  *
- * HCNet_DataArrives --
+ * hintCacheNetDataArrives --
  *
  *          Action to take when messages arrive from network.
  *
  * Arguments:
- *      char *data -- unaligned buffer of network-formatted HCNetUpdates
+ *      char *data -- unaligned buffer of network-formatted hintCacheNetUpdates
  *      int len -- number of bytes in that buffer
  *      struct sockaddr *source -- who sent the buffer
  *
@@ -212,11 +217,11 @@
  *------------------------------------------------4.2.1998------------
  */
 void
-HCNet_DataArrives(char *data, int len, HCNetHeader *hdr,
-	  struct sockaddr_in *source)
+hintCacheNetDataArrives(char *data, int len, HintCacheNetHeader * hdr,
+    struct sockaddr_in *source)
 {
     struct sockaddr_in sin;
-    HCUpdate *updatesA;
+    HintCacheUpdate *updatesA;
     int nupdates;
     int iupdate;
 
@@ -228,12 +233,12 @@
     assert(source->sin_family == AF_INET);
     assert(hdr->updlen >= HCU_MINLEN);
 
-    debug(HCNET_DEBUG, 3,
-	  "HCDataArrives: got %d bytes of stuff (probably %d updates xtra=%d\n",
-	   len, len / hdr->updlen, len % hdr->updlen);
+    debug(HCNET_DEBUG, 3)
+	("HintCacheDataArrives: got %d bytes of stuff (probably %d updates xtra=%d\n",
+	len, len / hdr->updlen, len % hdr->updlen);
 
     /* Copy to alignment buffer and local format */
-    updatesA = (HCUpdate *)xmalloc(len);
+    updatesA = (HintCacheUpdate *) xmalloc(len);
     nupdates = copyToLocal(updatesA, data, len, hdr->updlen);
 
     /* 
@@ -248,116 +253,116 @@
     source->sin_port = hdr->httpport;
 
     updateHierarchy(updatesA, nupdates, source);
-	
+
     /* 
      * Prefetch if we have a large number of requests.
      * Idea is to tell OS to start bringing in the pages
      * that we are about to touch.
      */
-    if (nupdates >= HCD_PREFETCH_THRESH){
-      HCDisk_prefetch(hcDisk, updatesA, nupdates);
+    if (nupdates >= HCD_PREFETCH_THRESH) {
+	hintCacheDisk_prefetch(hcDisk, updatesA, nupdates);
     }
 
     /*
      * OK. Now we can start processing the messages.
      */
-    for(iupdate = 0; iupdate < nupdates; iupdate++){
-      switch(updatesA[iupdate].action){
-      case HC_InvalToParent:
-	RECV_DEBUG("HC_InvalToParent", &updatesA[iupdate], hdr, source);
-	hcprop_handleInvalToParent(&updatesA[iupdate], source, 0);
-	break;
-
-      case HC_InvalToChild:
-	RECV_DEBUG("HC_InvalToChild", &updatesA[iupdate], hdr, source);
-	hcprop_handleInvalToChild(&updatesA[iupdate], source, 0);
-	break;
-
-      case HC_InformToParent:
-	RECV_DEBUG("HC_InformToParent", &updatesA[iupdate], hdr, source);
-	hcprop_handleInformToParent(&updatesA[iupdate], source, 0);
-	break;
-	    
-      case HC_InformToChild:
-	RECV_DEBUG("HC_InformToChild", &updatesA[iupdate], hdr, source);
-	hcprop_handleInformToChild(&updatesA[iupdate], source, 0);
-	break;
-
-      case HC_Join:
-        /* New cache node!  Add to list. */
-	RECV_DEBUG("HC_Join", &updatesA[iupdate], hdr, source);
-        /*
-         * MDD 7.18.1998 
-         * When a node relays a join/leave to us, make sure
-         * that we send future joins to that node by adding
-         * that node to the peer list if it's not already there.
-         */
-        sin.sin_family = AF_INET;
-        sin.sin_addr = source->sin_addr;
-        sin.sin_port = hdr->httpport;
-        HCHier_updateMembershipNeighbor(&sin, NEIGHBOR_ADD);
-
-        /*
-         * Now update local state for join
-         */
-        sin.sin_family = AF_INET;
-        sin.sin_addr = updatesA[iupdate].entry.ipaddr;
-        sin.sin_port = updatesA[iupdate].entry.port;
-        HCHier_newNode(&sin, updatesA[iupdate].hopcount, 
-                       updatesA[iupdate].entry.key.key);
-	break;
-
-      case HC_Leave:
-        /* Cache node is either dead or has been detected dead. */
-        RECV_DEBUG("HC_Leave", &updatesA[iupdate], hdr, source);
-        sin.sin_family = AF_INET;
-        sin.sin_addr = updatesA[iupdate].entry.ipaddr;
-        sin.sin_port = updatesA[iupdate].entry.port;
-        HCHier_delNode(&sin, updatesA[iupdate].hopcount, updatesA[iupdate].entry
-.key.key);
-
-        /*
-         * MDD 7.18.1998 
-         * When we receive a join from a node, make sure
-         * that we send future joins to that node by adding
-         * that node to the peer list if it's not already there.
-         */
-        HCHier_updateMembershipNeighbor(source, NEIGHBOR_ADD);
-        /*
-         * MDD 7.18.1998
-         * And the node we just heard about is gone, so it must
-         * no longer be a neighbor across which to propagate changes
-         * in membership.
-         */
-        HCHier_updateMembershipNeighbor(&sin, NEIGHBOR_REMOVE);
-	
-        break;
-
-      case HC_NotChild:
-	/*
-	 * This message should have been handled and suppressed
-	 * (by making it "HC_Ignore") in the updateHierarchy() code.
-	 */
-	RECV_DEBUG("HC_NotChild", &updatesA[iupdate], hdr, source);
-	assert(0);
-	break;
-
-      case HC_Ignore:
-	/* This message was suppressed either because it is
-	 * part of a loop or because it came from a node that
-	 * thinks it is my parent but isnt.
-	 */
-	break;
-
-      default:
-	/* Ignore bad messages */
-	debug(HCNET_DEBUG, 1, 
-	      "HCHintCache: unknown update action %d from net\n",
-	      updatesA[iupdate].action);
-	break;
-      }
+    for (iupdate = 0; iupdate < nupdates; iupdate++) {
+	switch (updatesA[iupdate].action) {
+	case HC_InvalToParent:
+	    RECV_DEBUG("hintCache_InvalToParent", &updatesA[iupdate], hdr, source);
+	    hcprop_handleInvalToParent(&updatesA[iupdate], source, 0);
+	    break;
+
+	case HC_InvalToChild:
+	    RECV_DEBUG("hintCache_InvalToChild", &updatesA[iupdate], hdr, source);
+	    hcprop_handleInvalToChild(&updatesA[iupdate], source, 0);
+	    break;
+
+	case HC_InformToParent:
+	    RECV_DEBUG("hintCache_InformToParent", &updatesA[iupdate], hdr, source);
+	    hcprop_handleInformToParent(&updatesA[iupdate], source, 0);
+	    break;
+
+	case HC_InformToChild:
+	    RECV_DEBUG("hintCache_InformToChild", &updatesA[iupdate], hdr, source);
+	    hcprop_handleInformToChild(&updatesA[iupdate], source, 0);
+	    break;
+
+	case HC_Join:
+	    /* New cache node!  Add to list. */
+	    RECV_DEBUG("hintCache_Join", &updatesA[iupdate], hdr, source);
+	    /*
+	     * MDD 7.18.1998 
+	     * When a node relays a join/leave to us, make sure
+	     * that we send future joins to that node by adding
+	     * that node to the peer list if it's not already there.
+	     */
+	    sin.sin_family = AF_INET;
+	    sin.sin_addr = source->sin_addr;
+	    sin.sin_port = hdr->httpport;
+	    hintCacheHier_updateMembershipNeighbor(&sin, NEIGHBOR_ADD);
+
+	    /*
+	     * Now update local state for join
+	     */
+	    sin.sin_family = AF_INET;
+	    sin.sin_addr = updatesA[iupdate].entry.ipaddr;
+	    sin.sin_port = updatesA[iupdate].entry.port;
+	    hintCacheHier_newNode(&sin, updatesA[iupdate].hopcount,
+		updatesA[iupdate].entry.key.key);
+	    break;
+
+	case HC_Leave:
+	    /* Cache node is either dead or has been detected dead. */
+	    RECV_DEBUG("hintCache_Leave", &updatesA[iupdate], hdr, source);
+	    sin.sin_family = AF_INET;
+	    sin.sin_addr = updatesA[iupdate].entry.ipaddr;
+	    sin.sin_port = updatesA[iupdate].entry.port;
+	    hintCacheHier_delNode(&sin, updatesA[iupdate].hopcount,
+		updatesA[iupdate].entry.key.key);
+
+	    /*
+	     * MDD 7.18.1998 
+	     * When we receive a join from a node, make sure
+	     * that we send future joins to that node by adding
+	     * that node to the peer list if it's not already there.
+	     */
+	    hintCacheHier_updateMembershipNeighbor(source, NEIGHBOR_ADD);
+	    /*
+	     * MDD 7.18.1998
+	     * And the node we just heard about is gone, so it must
+	     * no longer be a neighbor across which to propagate changes
+	     * in membership.
+	     */
+	    hintCacheHier_updateMembershipNeighbor(&sin, NEIGHBOR_REMOVE);
+
+	    break;
+
+	case HC_NotChild:
+	    /*
+	     * This message should have been handled and suppressed
+	     * (by making it "HC_Ignore") in the updateHierarchy() code.
+	     */
+	    RECV_DEBUG("HC_NotChild", &updatesA[iupdate], hdr, source);
+	    assert(0);
+	    break;
+
+	case HC_Ignore:
+	    /* This message was suppressed either because it is
+	     * part of a loop or because it came from a node that
+	     * thinks it is my parent but isnt.
+	     */
+	    break;
+
+	default:
+	    /* Ignore bad messages */
+	    debug(HCNET_DEBUG, 1)
+		("HCHintCache: unknown update action %d from net\n",
+		updatesA[iupdate].action);
+	    break;
+	}
     }
-    
+
     xfree(updatesA);
 }
 
@@ -381,22 +386,22 @@
  *-----------------------------------------------3.31.1998-----------
  */
 static int
-copyToLocal(HCUpdate *updatesA, char *data, int len, int oneUpdateSize)
+copyToLocal(HintCacheUpdate * updatesA, char *data, int len, int oneUpdateSize)
 {
-  char *alignbuf;
-  int uoff;
-  Net_HCUpdate *nupdatep;
-  int ii;
-
-  alignbuf = xmalloc(len);
-  memcpy(alignbuf, data, len);
-  
-  for (uoff = 0, ii = 0; uoff < len; uoff += oneUpdateSize, ii++) {
-    nupdatep = (Net_HCUpdate *) (alignbuf + uoff);
-    Net_HCUpdate_LocalFormat(nupdatep, &updatesA[ii]);
-  }
-  xfree(alignbuf);
-  return ii;
+    char *alignbuf;
+    int uoff;
+    HintCacheUpdateNet *nupdatep;
+    int ii;
+
+    alignbuf = xmalloc(len);
+    memcpy(alignbuf, data, len);
+
+    for (uoff = 0, ii = 0; uoff < len; uoff += oneUpdateSize, ii++) {
+	nupdatep = (HintCacheUpdateNet *) (alignbuf + uoff);
+	hintCacheUpdateNetLocalFormat(nupdatep, &updatesA[ii]);
+    }
+    xfree(alignbuf);
+    return ii;
 }
 
 /*
@@ -422,19 +427,19 @@
  *-----------------------------------------------4.1.1998-------------
  */
 static void
-suppress(HCUpdate *updateA, int nupdates)
+suppress(HintCacheUpdate * updateA, int nupdates)
 {
 #ifdef NOTYET
     /* Need to fill this in */
     int iupdate;
-    
-    for(iupdate = 0; iupdate < nupdates; iupdate++){
+
+    for (iupdate = 0; iupdate < nupdates; iupdate++) {
 	if (stoppable update) {
 	    updateA[iupdate].action = HC_Ignore;
 	}
     }
 #endif
-    
+
     return;
 }
 
@@ -468,46 +473,46 @@
  *------------------------------------------------4.1.1998------------
  */
 static void
-updateHierarchy(HCUpdate *updatesA, int nupdates, struct sockaddr_in *source)
+updateHierarchy(HintCacheUpdate * updatesA, int nupdates, struct sockaddr_in *source)
 {
-  int iupdate;
-  int parentScolded = 0;
+    int iupdate;
+    int parentScolded = 0;
 
-  for(iupdate = 0; iupdate < nupdates; iupdate++){
-    switch(updatesA[iupdate].action){
-    case HC_InformToChild:
-    case HC_InvalToChild:
-      if(!HCHier_CheckIfParent(updatesA[iupdate].entry.key, source)){
-	if(!parentScolded){
-	  scoldParent(source);
-	  parentScolded = 1;
-	}
-	updatesA[iupdate].action = HC_Ignore;
-      }
-      break;
-
-    case HC_InformToParent:
-    case HC_InvalToParent:
-#if 1  /* XXX! - disabling parent&child lists */
-      if(!HCHier_CheckIfChild(source)){
-	HCHier_AddChild(source);
-      }
+    for (iupdate = 0; iupdate < nupdates; iupdate++) {
+	switch (updatesA[iupdate].action) {
+	case HC_InformToChild:
+	case HC_InvalToChild:
+	    if (!HCHier_CheckIfParent(updatesA[iupdate].entry.key, source)) {
+		if (!parentScolded) {
+		    scoldParent(source);
+		    parentScolded = 1;
+		}
+		updatesA[iupdate].action = HC_Ignore;
+	    }
+	    break;
+
+	case HC_InformToParent:
+	case HC_InvalToParent:
+#if 1				/* XXX! - disabling parent&child lists */
+	    if (!hintCacheHier_CheckIfChild(source)) {
+		hintCacheHier_AddChild(source);
+	    }
 #endif
-      break;
+	    break;
 
-    case HC_NotChild:
-      HCHier_RemoveChild(source);
-      updatesA[iupdate].action = HC_Ignore;
-      break;
-      
-
-    default:
-      /*
-       * Other messages don't affect hierarchy. Ignore them here.
-       */
-      break;
+	case HC_NotChild:
+	    hintCacheHier_RemoveChild(source);
+	    updatesA[iupdate].action = HC_Ignore;
+	    break;
+
+
+	default:
+	    /*
+	     * Other messages don't affect hierarchy. Ignore them here.
+	     */
+	    break;
+	}
     }
-  }
 }
 
 /*
@@ -516,7 +521,7 @@
  * scoldParent --
  *
  *          Tell parent "I am not child". Need to use
- *          our own private HCNet queue since all of the
+ *          our own private HintCacheNet queue since all of the
  *          other queues are associated with the hierarchy
  *          and this message is to tell someone they
  *          are *not* in the hierarchy.
@@ -535,26 +540,24 @@
 static void
 scoldParent(struct sockaddr_in *parent)
 {
-  static int initialized = 0;
-  static HCNet netBuf;
-  static HCEntry dummyEntry;
-  static URLKey dummyKey;
-
-  debug(HCNET_DEBUG, 7, "In scoldParent %s\n", inet_ntoa(parent->sin_addr));
-
-  if(!initialized){
-    HCNet_Init(&netBuf);
-    URLKey_Init(&dummyKey, NULL);
-    HCEntry_Init(&dummyEntry, dummyKey,
-		 &Config.Sockaddr.http->s,
-		 squid_curtime);
-    initialized = 1;
-  }
-
-  HCNet_Enqueue(&netBuf, HC_NotChild, &dummyEntry, 1);
-  HCNet_Complete(&netBuf);
-  HCNet_SendTo(&netBuf, parent);
-  HCNet_Done(&netBuf);
-  return;
-}
+    static int initialized = 0;
+    static HintCacheNet netBuf;
+    static HintCacheEntry dummyEntry;
+    static URLKey dummyKey;
+
+    debug(HCNET_DEBUG, 7) ("In scoldParent %s\n", inet_ntoa(parent->sin_addr));
+
+    if (!initialized) {
+	hintCacheNetInit(&netBuf);
+	URLKey_Init(&dummyKey, NULL);
+	hintCacheEntry_Init(&dummyEntry, dummyKey,
+	    &Config.Sockaddr.http->s, squid_curtime);
+	initialized = 1;
+    }
 
+    hintCacheNetEnqueue(&netBuf, HC_NotChild, &dummyEntry, 1);
+    hintCacheNetComplete(&netBuf);
+    hintCacheNetSendTo(&netBuf, parent);
+    hintCacheNetDone(&netBuf);
+    return;
+}
